// Package org_accordproject_templatemark_0_4_0 contains domain objects and was generated from Concerto namespace org.accordproject.templatemark@0.4.0.
package org_accordproject_templatemark_0_4_0
import "org_accordproject_commonmark_0_5_0";
import "concerto_metamodel_1_0_0";
import "concerto_1_0_0";
   
type CodeType int
const (
   ES_2020 CodeType = 1 + iota
)
type Code struct {
   concerto_1_0_0.Concept
   Type CodeType `json:"type"`
   Contents string `json:"contents"`
}
type ElementDefinition struct {
   org_accordproject_commonmark_0_5_0.Child
   Name string `json:"name"`
   ElementType string `json:"elementType"`
   Decorators []Decorator `json:"decorators"`
}
type VariableDefinition struct {
   ElementDefinition
   IdentifiedBy string `json:"identifiedBy"`
}
type FormattedVariableDefinition struct {
   VariableDefinition
   Format string `json:"format"`
}
type EnumVariableDefinition struct {
   VariableDefinition
   EnumValues []string `json:"enumValues"`
}
type FormulaDefinition struct {
   ElementDefinition
   Dependencies []string `json:"dependencies"`
   Code Code `json:"code"`
}
type BlockDefinition struct {
   ElementDefinition
}
type ClauseDefinition struct {
   BlockDefinition
   Condition Code `json:"condition"`
}
type ContractDefinition struct {
   BlockDefinition
}
type WithDefinition struct {
   BlockDefinition
}
type ConditionalDefinition struct {
   BlockDefinition
   WhenTrue []Child `json:"whenTrue"`
   WhenFalse []Child `json:"whenFalse"`
   Condition Code `json:"condition"`
   Dependencies []string `json:"dependencies"`
}
type OptionalDefinition struct {
   BlockDefinition
   WhenSome []Child `json:"whenSome"`
   WhenNone []Child `json:"whenNone"`
}
type JoinDefinition struct {
   BlockDefinition
   Separator string `json:"separator"`
}
type ListBlockDefinition struct {
   BlockDefinition
   Type string `json:"type"`
   Tight string `json:"tight"`
   Start string `json:"start"`
   Delimiter string `json:"delimiter"`
}
type ForeachBlockDefinition struct {
   BlockDefinition
}
type WithBlockDefinition struct {
   BlockDefinition
}
type ConditionalBlockDefinition struct {
   BlockDefinition
   WhenTrue []Child `json:"whenTrue"`
   WhenFalse []Child `json:"whenFalse"`
   Condition Code `json:"condition"`
}
type OptionalBlockDefinition struct {
   BlockDefinition
   WhenSome []Child `json:"whenSome"`
   WhenNone []Child `json:"whenNone"`
}
